import { __rest, __assign } from './../external/tslib/tslib.es6.js';
import React from 'react';
import classnames from 'classnames';
import { parseMetadata } from '@highlight-ui/utils-commons';
import { Icon } from '@highlight-ui/icon';
import { IconButton } from '@highlight-ui/button';
import { Typography } from '@highlight-ui/typography';
import Actions from './Actions.js';
import statusToIconName from './statusToIconName.js';
import styles from './Alert.module.scss.js';

function AlertWithRef(_a, ref) {
  var _b, _c;

  var actions = _a.actions,
      children = _a.children,
      className = _a.className,
      _d = _a.enableCloseButton,
      enableCloseButton = _d === void 0 ? false : _d,
      _e = _a.fullWidth,
      fullWidth = _e === void 0 ? false : _e,
      iconColor = _a.iconColor,
      _f = _a.iconFamily,
      iconFamily = _f === void 0 ? 'solid' : _f,
      iconName = _a.iconName,
      _g = _a.iconSize,
      iconSize = _g === void 0 ? 16 : _g,
      iconClassName = _a.iconClassName,
      metadata = _a.metadata,
      onClickCloseButton = _a.onClickCloseButton,
      status = _a.status,
      remainingProps = __rest(_a, ["actions", "children", "className", "enableCloseButton", "fullWidth", "iconColor", "iconFamily", "iconName", "iconSize", "iconClassName", "metadata", "onClickCloseButton", "status"]);

  var statusIconColor = "icon-" + status;
  var statusIconName = statusToIconName(status);
  return /*#__PURE__*/React.createElement("div", __assign({}, remainingProps, parseMetadata(metadata), {
    className: classnames(styles.alertContainer, className),
    ref: ref
  }), /*#__PURE__*/React.createElement("div", {
    className: classnames(styles.alertInner, styles["alertInner-" + status], (_b = {}, _b[styles.alertFullWidth] = fullWidth, _b))
  }, /*#__PURE__*/React.createElement("div", {
    className: styles.alertContent
  }, /*#__PURE__*/React.createElement("span", {
    className: classnames(styles.icon, iconClassName)
  }, /*#__PURE__*/React.createElement(Icon, {
    name: iconName !== null && iconName !== void 0 ? iconName : statusIconName,
    color: iconColor !== null && iconColor !== void 0 ? iconColor : statusIconColor,
    size: iconSize,
    type: iconFamily
  })), children && /*#__PURE__*/React.createElement(Typography, {
    variant: "body-1",
    className: classnames(styles.alertBodyContainer, (_c = {}, _c[styles.alertFullWidth] = fullWidth, _c))
  }, children), enableCloseButton && /*#__PURE__*/React.createElement(IconButton, {
    className: styles.alertCloseButton,
    onClick: onClickCloseButton,
    type: "button",
    icon: "times",
    ariaLabel: "close alert"
  })), actions && /*#__PURE__*/React.createElement(Actions, null, actions)));
}

AlertWithRef.displayName = 'Alert';
var Alert = /*#__PURE__*/React.forwardRef(AlertWithRef);
export { AlertWithRef, Alert as default };
//# sourceMappingURL=Alert.js.map
